//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "SMTPAuthDlgs.h"
#include "SMTPPassDlgs.h"
#include "fileman.h"
#include "global.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TSMTPAuthDlg *SMTPAuthDlg;
//---------------------------------------------------------------------------
void __fastcall ManageSMTPPasswords(TForm *Owner)
{
   SMTPAuthDlg = new TSMTPAuthDlg(Owner);
   SMTPAuthDlg->ShowModal();
   delete SMTPAuthDlg;
}
//---------------------------------------------------------------------------
__fastcall TSMTPAuthDlg::TSMTPAuthDlg(TComponent* Owner)
	: TForm(Owner)
{
   CenterDialog(this,(TForm*)Owner);
   hosts = new TStringList(); hosts->Sorted = true;
   GetAppData(hosts,SMTPAuthenticHosts);
   LoadHostList();
   modified = false;
}
//---------------------------------------------------------------------------
__fastcall TSMTPAuthDlg::~TSMTPAuthDlg()
{
   delete hosts;
}
//---------------------------------------------------------------------------
void __fastcall TSMTPAuthDlg::LoadHostList()
{
   HostList->Clear();
   for (int i=0; i<hosts->Count; i++)
      HostList->Items->Add(hosts->Names[i]);
}
//---------------------------------------------------------------------------
void __fastcall TSMTPAuthDlg::HostListClick(TObject *Sender)
{
   if (HostList->ItemIndex>=0)
   {
      DeleteBtn->Enabled = true;
      EditBtn->Enabled = true;
   }
}
//---------------------------------------------------------------------------
void __fastcall TSMTPAuthDlg::NewBtnClick(TObject *Sender)
{
   AnsiString host,password;
   if (SMTPGetHostPassword(this,host,password))
   {
      hosts->Values[host] = password;
      modified = true;
      LoadHostList();
   }
}
//---------------------------------------------------------------------------
void __fastcall TSMTPAuthDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (ModalResult==mrOk && modified) PutAppData(SMTPAuthenticHosts,hosts);
   if (ModalResult==mrCancel && modified)
   {
      switch(MsgBoxHwnd(Handle,
        "Your host list is modified.\n\nSave your changes?",
        "Confirm",MB_YESNOCANCEL))
      {
         case IDYES: PutAppData(SMTPAuthenticHosts,hosts); break;
         case IDCANCEL: CanClose = false; break;
      }
   }
}
//---------------------------------------------------------------------------
